

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                   *
    *   Some DSP 0.2                                                    *
    *                                                                   *
    *   Copyright  2005   Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                   *
    *   --> http://www.hartwork.org                                     *
    *                                                                   *
    *                                                                   *
    *   This source code is released under LGPL.                        *
    *   See LGPL.txt for details.                                       *
    *                                                                   *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#include "mod_boost.h"


void config_boost( struct winampDSPModule * this_mod );
int init_boost( struct winampDSPModule * this_mod );
int apply_boost( struct winampDSPModule * this_mod, short int * samples, int numsamples, int bps, int nch, int srate );
void quit_boost( struct winampDSPModule * this_mod );


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
winampDSPModule mod_boost =
{
	"Boost Arctangent",
	NULL,			// hwndParent
	NULL,			// hDllInstance
	config_boost,
	init_boost,
	apply_boost,
	quit_boost
};


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
void config_boost( struct winampDSPModule * this_mod )
{
	MessageBox(	this_mod->hwndParent,
				"Boost Arctangent\n"
				"\n"
				"Copyright  2005 Sebastian Pipping    \n"
				"--> http://www.hartwork.org",
				"About",
				MB_ICONINFORMATION );
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
int init_boost( struct winampDSPModule * this_mod )
{
	return 0;	// Fine
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
inline short int boost_sample( short int sample )
{
	static const double tan1 = tan( 1.0 );
	return ( short int )( 32768.0 * atan( sample / 32768.0 * tan1 ) );
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
int apply_boost( struct winampDSPModule * this_mod, short int * samples, int numsamples, int bps, int nch, int srate )
{
	const int block_len = numsamples * nch;
	static int i;	// Same each time == less mem

	for( i = 0; i < block_len; i++ )
	{
		samples[ i ] = boost_sample( samples[ i ] );
	}

	return numsamples;
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
void quit_boost( struct winampDSPModule * this_mod )
{

}
