

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                   *
    *   Some DSP 0.2                                                    *
    *                                                                   *
    *   Copyright  2005   Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                   *
    *   --> http://www.hartwork.org                                     *
    *                                                                   *
    *                                                                   *
    *   This source code is released under LGPL.                        *
    *   See LGPL.txt for details.                                       *
    *                                                                   *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#include <windows.h>
#include "Winamp/dsp.h"

#include "Modules/mod_bypass.h"
#include "Modules/mod_boost.h"
#include "Modules/mod_delay.h"
#include "Modules/mod_revster.h"


#ifdef __cplusplus
# define DLLEXPORT extern "C" __declspec( dllexport )
#else
# define DLLEXPORT __declspec( dllexport )
#endif


winampDSPModule * getModule( int which );


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
winampDSPHeader header =
{
	DSP_HDRVER,
	"Some DSP 0.2 // 2005-04-29",
	getModule
};


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
DLLEXPORT winampDSPHeader * winampDSPGetHeader2()
{
	return &header;
}


////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
winampDSPModule * getModule( int which )
{
	switch( which )
	{
		case 0:
			return &mod_bypass;

		case 1:
			return &mod_boost;

		case 2:
			return &mod_delay;

		case 3:
			return &mod_revster;

		default:
			return NULL;
	}
}
